#ifndef STATIC_CONTAINER_LIST_HASH_H

#define STATIC_CONTAINER_LIST_HASH_H

#include "static_container/hash.h"
#include "static_container/list.h"

namespace static_container {
	///	hash ƁAlist gݍ킹WnbV
	template < typename Key, typename Value, size_type MaxSize, typename KeyEqual = std::equal_to< Key > >
	class list_hash : public hash< Key, Value, list< std::pair< Key, Value >, MaxSize >, KeyEqual > {
	public:
		typedef hash< Key, Value, list< std::pair< Key, Value >, MaxSize >, KeyEqual >	parent;
		
		typedef typename parent::value_type			value_type;
		typedef typename parent::reference			reference;
		typedef typename parent::const_reference	const_reference;
		typedef typename parent::iterator			iterator;
		typedef typename parent::const_iterator		const_iterator;
		typedef typename parent::size_type			size_type;

		list_hash( key_equal equal = KeyEqual() ) : parent( equal ) {}
	};
}

#endif
