#ifndef STATIC_CONTIANER_TEST_DUMP_H

#define STATIC_CONTIANER_TEST_DUMP_H

#include <boost/test/minimal.hpp>
#include <sstream>

namespace static_container {
	namespace test {
		///	oCit@Cւ̒ڏ݁Eǂݍ݃eXg
		template < typename Cont >
		void dump( const Cont& cont ) {
			char	fileImage1[ sizeof( Cont ) ];
			char	fileImage2[ sizeof( Cont ) ];
			
			memcpy( fileImage1, &cont, sizeof( Cont ) );
			memcpy( fileImage2, fileImage1, sizeof( Cont ) );
			Cont* dest = reinterpret_cast< Cont* >( fileImage2 );
			BOOST_REQUIRE( cont == *dest );
		}
		
		template < typename ContGen >
		void dump() {
			ContGen::gen< int, 10 >::type	iv;
			test::dump( iv );
			
			iv.push_back( 100 );
			iv.push_back( 50 );
			test::dump( iv );
		}
	}
}

#endif