#include "static_container/test/assert_new.h"
#include <boost/test/minimal.hpp>
#include "static_container/vector.h"
#include "static_container/test/basic_sequence.h"
#include "static_container/test/dump.h"

using namespace static_container;

struct vectorgen {
	template < typename Value, size_type Size >
	struct gen {
		typedef vector< Value, Size >	type;
	};
};

///	@test static_container::vector
int test_main( int argc, char* argv[] ) {
	test::begin(); // new Ăяoɓ{苶I
	test::basic_sequence< vectorgen >();
	test::dump< vectorgen >();
	return 0;
}
